market/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import redirect
from drf_spectacular.views import SpectacularAPIView, SpectacularSwaggerView, SpectacularRedocView

urlpatterns = [
    path('', lambda request: redirect('products:list')),
    path('admin/', admin.site.urls),
    path('products/', include('products.web.urls')),
    path('users/', include('users.web.urls')),
    path('api/', include('products.rest_api.urls')),
    path('api/users/', include('users.rest_api.urls')),

    path('api/schema/', SpectacularAPIView.as_view(), name='schema'),
    path('api/schema/swagger-ui/', SpectacularSwaggerView.as_view(url_name='schema'), name='swagger-ui'),
    path('api/schema/redoc/', SpectacularRedocView.as_view(url_name='schema'), name='redoc'),

]

products/rest_api/urls.py
from rest_framework.routers import DefaultRouter
from .views import ProductModelViewSet, CategoryModelViewSet

router = DefaultRouter()
router.register(r'products', ProductModelViewSet)
router.register(r'category', CategoryModelViewSet)

urlpatterns = router.urls

products/web/urls.py
from django.urls import path
from .views import (
    ProductListView,
    CreateProductView,
    ProductUpdateView,
    ProductDeleteView,
    CategoryUpdateView,
    CategoryProductListView,
    CategoryProductDeleteView,
    CreateCategoryProductView
)

app_name = 'products'

urlpatterns = [
    path('', ProductListView.as_view(), name='list'),
    path('add/', CreateProductView.as_view(), name='add'),
    path('<int:pk>/', ProductUpdateView.as_view(), name='update'),
    path('delete/<int:pk>/', ProductDeleteView.as_view(), name='delete'),
    path('category/<int:pk>/', CategoryUpdateView.as_view(), name='category_update'),
    path('category/list/', CategoryProductListView.as_view(), name='category_list'),
    path('category/add/', CreateCategoryProductView.as_view(), name='category_add'),
    path('delete/category/<int:pk>/', CategoryProductDeleteView.as_view(), name='delete_category'),

]

products/models.py
from django.db import models


class ProductCategory(models.Model):
    """Category class only for products"""
    title = models.CharField(verbose_name='Заголовок', max_length=50)
    parent_category = models.ManyToManyField('self', verbose_name='Родительская категория', null=True, blank=True)

    # data_created = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.title


class Product(models.Model):
    """Class Product"""
    title = models.CharField(verbose_name='Заголовок', max_length=50)
    price = models.DecimalField(verbose_name='Цена', max_digits=10, decimal_places=2)
    category = models.ForeignKey(ProductCategory, verbose_name='Категория', on_delete=models.SET_NULL, null=True,
                                 blank=True)

    # data_created = models.DateTimeField(auto_now_add=True)

    def __str__(self):
        return self.title

products/web/forms.py
from django import forms
from products.models import Product, ProductCategory


class ProductForm(forms.ModelForm):
    class Meta:
        model = Product
        fields = ['title', 'price', 'category']
        labels = {
            'title': 'Заголовок',
            'price': 'Цена',
            'category': 'Категория'
        }


class CategoryForm(forms.ModelForm):
    class Meta:
        model = ProductCategory
        fields = ['title', 'parent_category']
        labels = {
            'title': 'Заголовок',
            'parent_category': 'Категория',

        }

products/rest_api/views.py
from rest_framework.viewsets import ModelViewSet
from products.models import Product, ProductCategory
from .serializers import ProductSerializer, CategorySerializer


class ProductModelViewSet(ModelViewSet):
    queryset = Product.objects.select_related('category').all()
    serializer_class = ProductSerializer


class CategoryModelViewSet(ModelViewSet):
    queryset = ProductCategory.objects.prefetch_related('parent_category').all()
    serializer_class = CategorySerializer

products/web/views.py
from django.views.generic import ListView, CreateView, DeleteView, UpdateView
from django.urls import reverse_lazy
from products.models import Product, ProductCategory

from products.web.forms import ProductForm, CategoryForm


class ProductListView(ListView):
    """View for getting a list of products"""

    model = Product
    context_object_name = 'products'
    template_name = 'products/list.html'

    def get_queryset(self):
        # Query with joining categories and
        # getting only the name of the category for which you don't need to load databases.
        queryset = self.model.objects.select_related('category').values(
            'title',
            'price',
            'category__title',
            'category__pk',
            'pk')

        return queryset


class CreateProductView(CreateView):
    """View for creating a product."""

    model = Product
    template_name = 'products/add.html'
    form_class = ProductForm

    def get_success_url(self):
        return reverse_lazy('products:update', kwargs={'pk': self.object.pk})


class ProductUpdateView(UpdateView):
    """View for updating a product."""
    model = Product
    template_name = 'products/detail.html'
    form_class = ProductForm

    def get_success_url(self):
        return reverse_lazy('products:update', kwargs={'pk': self.object.pk})


class ProductDeleteView(DeleteView):
    """View for deleting a product."""
    model = Product
    success_url = reverse_lazy('products:list')


class CategoryUpdateView(UpdateView):
    """View for updating a product."""
    model = ProductCategory
    template_name = 'products/category_update.html'
    form_class = CategoryForm

    def get_success_url(self):
        return reverse_lazy('products:update', kwargs={'pk': self.object.pk})


class CategoryProductListView(ListView):
    """View for getting a list of category"""

    model = ProductCategory
    context_object_name = 'categories'
    template_name = 'products/category_list.html'

    def get_queryset(self):
        # Query with joining parent_category and
        # getting only the title, pk of the parent_category for which you don't need to load databases.
        queryset = self.model.objects.prefetch_related('parent_category').values('title', 'pk')

        return queryset


class CategoryProductDeleteView(DeleteView):
    """View for deleting a category."""
    model = Product
    success_url = reverse_lazy('products:category_list')


class CreateCategoryProductView(CreateView):
    """View for creating a product category."""

    model = ProductCategory
    template_name = 'products/add_category.html'
    form_class = CategoryForm

    def get_success_url(self):
        return reverse_lazy('products:category_list')

templates/products/add.html
{% extends 'base.html' %}

{% block title %} Products {% endblock %}

{% block content %}
<form action="{% url 'products:add'%}" method="post">
    {% csrf_token %}
    {{form}}
    <input type="submit" name="">
</form>


{% endblock %}

templates/products/add_category.html
{% extends 'base.html' %}

{% block title %} Products {% endblock %}

{% block content %}
<form action="{% url 'products:category_add'%}" method="post">
    {% csrf_token %}
    {{form}}
    <input type="submit" name="">
</form>


{% endblock %}

templates/products/category_confirm_delete.html
{% extends 'base.html' %}

{% block title %}Confirm Delete Product{% endblock %}

{% block content %}
<h2>Confirm Delete Product</h2>
<p>Are you sure you want to delete the category "{{ object }}"?</p>
<form method="post">
    {% csrf_token %}
    <button type="submit">Confirm</button>
</form>
{% endblock %}

templates/products/category_list.html
{% extends 'base.html' %}

{% block title %} Category list {% endblock %}

{% block content %}

{% for category in categories %}
<div>
    <div><a href="{% url 'products:category_update' category.pk %}">{{category.title}}</a></div>
    <button><a href="{% url  'products:delete_category' category.pk %}">delete</a></button>
</div>

{% endfor %}

{% endblock %}

templates/products/category_update.html
{% extends 'base.html' %}

{% block title %} Products Category{% endblock %}

{% block content %}
<form action="{% url 'products:update'  form.instance.pk %}" method="post">
    {% csrf_token %}
    {{form.as_p}}
    <input type="submit" name="">
</form>


{% endblock %}

templates/products/detail.html
{% extends 'base.html' %}

{% block title %} Products {% endblock %}

{% block content %}
<form action="{% url 'products:update'  form.instance.pk %}" method="post">
    {% csrf_token %}
    {{form.as_p}}
    <input type="submit" name="">
</form>


{% endblock %}

templates/products/list.html
{% extends 'base.html' %}

{% block title %} Products {% endblock %}

{% block content %}

{% for product in products %}
<div>
    <div><a href="{% url 'products:update' product.pk %}">{{product.title}}</a></div>
    <div>{{product.price}}</div>
    <div><a href="{% url 'products:category_update' product.category__pk %}">{{product.category__title}}</a></div>
    <button><a href="{% url  'products:delete' product.pk %}">delete</a></button>
</div>

{% endfor %}

{% endblock %}

templates/products/product_confirm_delete.html
{% extends 'base.html' %}

{% block title %}Confirm Delete Product{% endblock %}

{% block content %}
<h2>Confirm Delete Product</h2>
<p>Are you sure you want to delete the product "{{ object }}"?</p>
<form method="post">
    {% csrf_token %}
    <button type="submit">Confirm</button>
</form>
{% endblock %}